local a = CreateFrame("Frame")
a.enabled = false
a.flipped = nil

local function findNamePlateByName( name )
 local kids = {WorldFrame:GetChildren()}
 for _,v in pairs(kids) do
  if v:IsVisible() then
   local child1 = v:GetChildren()
   if child1 and (child1:GetObjectType() == "StatusBar") then
    local regs = {v:GetRegions()}
    for _,k in pairs(regs) do
	 if (k:GetObjectType() == "FontString") and (k:GetText() == name) then
	  return v, k:GetText();
	 end
	end
   end
  end
 end
 return nil;
end

local function AdjustCamera( self, elapse )
plate = findNamePlateByName( self.name )
if not plate then
if self.state == 0 then
   if self.flipped then FlipCameraYaw(-180) self.flipped = nil end
   SetView(2)SetView(2)
   self.state = 1
elseif self.state == 1 and self.timeout < 0.2 then
 FlipCameraYaw(180)
 self.flipped = true
 self.state = 2
end
end
 if plate and not self.done then
  self.state = 3
  local fx, fy = plate:GetCenter()
  fy = fy - 40
  local mx, my = GetCursorPosition()
  local dx = fx - mx
  local dy = fy - my
  MoveViewLeftStart( dx/100 )
  MoveViewOutStart( dy/10 )
  if not self.lock and abs(dx) < 5 and abs(dy) < 5 then
   self.done = true
  end
 else
   if ( self.state == 3 ) or ( self.timeout < 0 ) then
   disablePlates(self)
   MoveViewLeftStop() MoveViewDownStop() MoveViewOutStop() self:SetScript("OnUpdate",nil)return
   else
   self.timeout = self.timeout - elapse
   end
 end
end

function enablePlates( a )
  if not a.enabled then
  a.enabled = true
  a.Overlap = GetCVar( "nameplateAllowOverlap" )
  a.Enemies = GetCVar( "nameplateShowEnemies" )
  a.Enemyguard = GetCVar( "nameplateShowEnemyGuardians" )
  a.Enemypet = GetCVar( "nameplateShowEnemyPets" )
  a.Enemytot = GetCVar( "nameplateShowEnemyTotems" )
  a.Friendguard = GetCVar( "nameplateShowFriendlyGuardians" )
  a.Friendpet = GetCVar( "nameplateShowFriendlyPets" )
  a.Friendtot = GetCVar( "nameplateShowFriendlyTotems" )
  a.Friends = GetCVar( "nameplateShowFriends" )
  SetCVar( "nameplateAllowOverlap", 1 )
  SetCVar( "nameplateShowEnemies", 1 )
  SetCVar( "nameplateShowEnemyGuardians", 1 )
  SetCVar( "nameplateShowEnemyPets", 1 )
  SetCVar( "nameplateShowEnemyTotems", 1 )
  SetCVar( "nameplateShowFriendlyGuardians", 1 )
  SetCVar( "nameplateShowFriendlyPets", 1 )
  SetCVar( "nameplateShowFriendlyTotems", 1 )
  SetCVar( "nameplateShowFriends", 1 )
  end
end

function disablePlates( a )
  if a.enabled then
  a.enabled = nil
  SetCVar( "nameplateAllowOverlap", a.Overlap )
  SetCVar( "nameplateShowEnemies", a.Enemies )
  SetCVar( "nameplateShowEnemyGuardians", a.Enemyguard )
  SetCVar( "nameplateShowEnemyPets", a.Enemypet )
  SetCVar( "nameplateShowEnemyTotems", a.Enemytot )
  SetCVar( "nameplateShowFriendlyGuardians", a.Friendguard )
  SetCVar( "nameplateShowFriendlyPets", a.Friendpet )
  SetCVar( "nameplateShowFriendlyTotems", a.Friendtot )
  SetCVar( "nameplateShowFriends", a.Friends )
  end
end

function lookAt( name, lock )
  a.timeout = 0.3
  a.name = name
  a.state = 0
  a.done = nil
  a.lock = lock
  enablePlates( a )
  a:SetScript("OnUpdate",function(self,e) AdjustCamera( self, e ) end)
end

SLASH_PANKERLOOK1 = "/pnklook"
SlashCmdList["PANKERLOOK"] = function(msg, editbox)
  local name, lock = string.match( msg, "(%a+)%s*(%w*)")
  if not name or name == "" then
   DEFAULT_CHAT_FRAME:AddMessage("Usage: /pnklook (name) [\"lock\"]" )
   return
  end
  if lock == "lock" or lock == "1" then
   lookAt( name, true )
  else
   lookAt( name, false )
  end
end
